0103abc

0103abc 的网站

= 算法、题解与学习记录 =

文章列表

题解

2026-11-04

496 字

先不管 $A=B=0$ 的情况,构造 $A3=1$ 只需要做比较 $1=[0<A0+A1]$ 然后自己加自己就可以构造出 $2$ 的幂次。然后拆二进制位,从高位到低位考虑 $A$ 并维护已经确定的高位和 $s$ 则第 $i$ 位的值可以被表示为 $bi=[s+2^i<A+1]$ 然后顺便维护 $s$...

题解

2026-11-04

1290 字

套路的拆分信息,注意到如果一个 $n\times n$ 和一个 $m\times m$ 的合法构造每一行上的骨牌数相同,则可以一个放在左上角一个放在右下角合并成一个新的骨牌数不变的 $(n+m)\times(n+m)$ 的合法构造。打个表发现 $4\times 4,5\times 5,6\times...

题解

2026-11-02

764 字

来复读一下第一篇题解。 直接枚举所有排列显然你是不可行的,因此考虑枚举哪些边紧密相连。钦定若干条边相邻是简单的,因此考虑子集反演,给每条边染成黑 / 白 / 灰三种颜色,其中黑边要求强制相邻并保留在最终的连通块中,白边要求强制相邻且不保留到最终连通块中(贡献为...

2026-11-02

55 字

从这里开始 写下你的想法。右侧是博客实际的排版,手机上可以切换到预览。

0
做题记录

2026-11-02

13 字

https://www.luogu.com.cn/record/307512191 https://codeforces.com/contest/2122/submission/397015963 https://codeforces.co...

题解

2026-10-28

1672 字

~~题目名居然过审了,好神奇~~ Fibonacci 数列有经典结论 $\gcd(fa,fb)=f{\gcd(a,b)}$,因此考虑 gcd-lcm 反演,$\operatorname{lcm}(f{a1},f{a2},\ldots,f{a...

题解

2026-10-26

830 字

首先问题可以被转化为计数长度为 $n$ 的整数序列 $a$ 满足下面两个条件: $1\le ai\le bi$($b_i$ 是所有对序列限制的上界) 序列恰好有 $k-1$ 个位置 $i$ 满足 $ai>a{i+1}$。 考虑 dp。设 $f{i,j}$ 表示当前考虑了前 $i$ 个位置,被切成了...

题解

2026-10-25

3149 字

Official Solution. sol 1 sol: Lemansky Time:2024/05 首先看到 XOR 构造容易想到一个经典的套路:$2k\oplus(2k+1)=1$(partner),不妨把这样的组合称为 P。 先考虑无解的情况,显然 $x$ 的最高位不能超过...

题解

2026-10-25

1400 字

Official Solution. 同样考虑 dp。设 $f{i,j}$ 表示因为其祖先结点不断失败,导致结点 $i$ 总共需要被重新通关 $j$ 次时,完成 $i$ 为根子树这一部分所需要的最小期望代价是多少。考虑如果 $i$ 需要成功 $j$ 次,因为单次成功的概率是 $\frac...

题解

2026-10-25

556 字

Official Solution. 因为 $n$ 个数最多有 $2^n$ 种选取方法,而需要覆盖的数的数量也是 $2^n$,这就告诉我们构造的序列 $a,b$ 需要满足所有的子集的异或均两两不同。 最小值 构造 $a_i=2^{i-1}$ 即可。很显然不能得到和更小的序列。 最大值 构造序列...

精选分类

随机文章

加载中...